

#ifndef ATMOSPH_H
#define ATMOSPH_H


/*****************************************************************************
* Global preprocessor defines
******************************************************************************/

/* Define fog types. DMF */

#define ORIG_FOG    1
#define GROUND_MIST 2
#define FOG_TYPES   2

/*****************************************************************************
* Global typedefs
******************************************************************************/


struct FOG
{
  int Type;
  DBL Distance;
  DBL Alt;
  DBL Offset;
  COLOUR Colour;
  VECTOR Up;
  TURB *Turb;
  SNGL Turb_Depth;
  FOG *Next;


FOG();
virtual ~FOG();
virtual FOG* GetCopy();
};

struct RAINBOW
{
  DBL Distance;
  DBL Jitter;
  DBL Angle, Width;
  DBL Arc_Angle, Falloff_Angle, Falloff_Width;
  VECTOR Antisolar_Vector;
  VECTOR Up_Vector, Right_Vector;
  PIGMENT *Pigment;
  RAINBOW *Next;

  RAINBOW();
virtual ~RAINBOW();
virtual RAINBOW* GetCopy();

};

struct SKYSPHERE
{
  int Count;           /* Number of pigments.       */
  PIGMENT **Pigments;  /* Pigment(s) to use.        */
  TRANSFORM *Trans;    /* Skysphere transformation. */

    SKYSPHERE();
virtual ~SKYSPHERE();
virtual SKYSPHERE* GetCopy();

  virtual void Scale( VECTOR Vector);
virtual void Rotate( VECTOR Vector);
virtual void Translate( VECTOR Vector);
virtual void Transform( TRANSFORM *Transf);

};





/*****************************************************************************
* Global functions
******************************************************************************/


void Do_Infinite_Atmosphere (RAY *Ray, COLOUR Colour);
void Do_Finite_Atmosphere (RAY *Ray, INTERSECTION *Intersection, COLOUR Colour, int Light_Source_Flag);



#endif
